<script setup lang="ts">
  import { PROMOTION_TYPE } from '~/helpers/constants';
  const { cartItems, subtotal, totalPrice, tax, shippingTotal, cartErrors } = useCart();

  const cartMessage = computed(() => {
    const keys = Object.keys(cartErrors.value ?? {});
    return keys.length > 0 ? cartErrors.value?.[keys[0]]?.message ?? '' : '';
  });
</script>

<template>
  <div class="md:bg-background-raised flex flex-col rounded-lg md:sticky md:top-8 md:p-6">
    <h1 class="text-xl md:text-[1.75rem]/8">{{ $t('checkout.summary') }}</h1>
    <div v-if="cartMessage" class="pt-3">
      <SwBanner type="inline" variant="warning" :show-close-btn="false">
        {{ cartMessage }}
      </SwBanner>
    </div>
    <div v-for="cartItem in cartItems" :key="cartItem.id">
      <CheckoutCartItem :data="cartItem" :is-promote-code="cartItem.type === PROMOTION_TYPE" />
    </div>
    <div class="flex justify-between pt-3 text-sm/6">
      <p>{{ $t('checkout.subtotal') }}</p>
      <SwPrice :value="subtotal" class="font-medium" :has-asterisk="false" />
    </div>
    <!-- TODO: implement total discount next phase -->
    <!-- <div v-if="totalDiscount" class="flex justify-between pt-1 text-sm/6">
      <p>{{ $t('cart.discounts') }}</p>
      <SwPrice :value="totalDiscount" class="font-medium text-emerald-900" :has-asterisk="false" />
    </div> -->
    <div class="flex justify-between pt-1 text-sm/6">
      <p>{{ $t('cart.tax') }}</p>
      <SwPrice :value="tax" class="text-success font-medium" :has-asterisk="false" />
    </div>

    <div class="flex justify-between pt-1 text-sm/6">
      <p>{{ $t('checkout.shippingPriceLabel') }}</p>
      <SwPrice :value="shippingTotal" class="font-medium" :has-asterisk="false" />
    </div>

    <ApplyPromotionCode />

    <div class="flex justify-between pt-3 text-lg/[1.625rem] font-semibold">
      <p>{{ $t('checkout.grandTotal') }}</p>
      <SwPrice :value="totalPrice" :has-asterisk="false" />
    </div>
  </div>
</template>
